#include "pvm3.h"

/* Hana Butkova, A06076 */

main() {

  int mytid;      /*  identifikator procesu delnik  */

  int chief_tid;  /*  identifikator procesu sef  */

  int x_num;      /*  pocet souradnic */
  int result;

  int cnt_work = 0; /*  velikost prace - pocet souradnic */

  int k;          /*  pomocna promenna */
  
  int *matrix1, *matrix2; /* matice, ktere se maji nasobit */
  int grade;    /* stupen matice */
  int *rslt;    /* vysledek */
  int tmp;
  
  int sum = 0;
	int m = 0;
	int row, col;
	int i;

  mytid = pvm_mytid();  /* prihlaseni do PVM */


  /* cekani na zpravu od sefa */

  pvm_recv(-1, 4);               /* 4 je kod zpravy */
  pvm_upkint(&chief_tid, 1, 1);  /* zjisti cislo sefa */  


  /* kontrola zda je sef ten pravy - totozny s otcem */ 

  if (chief_tid == pvm_parent()) {

    /* odpoved sefovi */  
    pvm_initsend(PvmDataDefault);/* inic. bufferu */
    pvm_pkint(&mytid, 1, 1);    /* ulozeni identifikace */
    pvm_pkint(&cnt_work, 1, 1); /* ulozeni citace */
    pvm_send(chief_tid, 5);     /* kod odpovedi 5 */
  }

  /* delnik pracuje */
  while (1) {

  pvm_recv(chief_tid, 8);               /* 8 - prijem matic */
  
  /* nacteni stupne matice */
  pvm_upkint(&grade, 1, 1);
  
  if (grade < 0){
      pvm_initsend(PvmDataDefault);// inic. bufferu 
      pvm_pkint(&mytid, 1, 1);    // ulozeni identifikace 
      pvm_pkint(&x_num, 1, 1);    // ulozeni ukoncovaciho zpravy 
      pvm_pkint(&cnt_work, 1, 1); // ulozeni citace prace 
      pvm_send(chief_tid, 7);                     
      break;                    // zaporna hodnota znamena konec prace  
  }
  
  // ulozeni prvni matice  
  matrix1 = (int *) malloc(grade * grade * sizeof(int));	    
  for (i = 0; i < grade * grade; i++){
    pvm_upkint(&tmp, 1, 1);
    *(matrix1 + i) = tmp;
  }  
  // ulozeni druhe matice
  pvm_upkint(&grade, 1, 1);  
  matrix2 = (int *) malloc(grade * grade * sizeof(int));	    
  for (i = 0; i < grade * grade; i++){
    pvm_upkint(&tmp, 1, 1);
    *(matrix2 + i) = tmp;
  }
  

  while (1) {  

    pvm_recv (chief_tid, 6);   /* cteni  prikazu */
    pvm_upkint (&x_num, 1, 1); /* ulozeni poctu zasilanych souradnic */    

    if (x_num < 0) {       
      break;                    // zaporna hodnota znamena konec prace
    }    
    
    rslt = (int *) malloc(x_num * 2 * sizeof(int));	  /* alokovani mista pro vysledek */
    /* vypocet hodnot prvku matice */
    for (i = 0; i < x_num; i++){
      pvm_upkint (&tmp, 1, 1);
      /* ulozeni cisla souradnice do vysledku */
      *(rslt + 2 * i) = tmp;      
      
      sum = 0;
      row = tmp / grade;
      col = tmp % grade;
      /* vypocet hodnoty prvku */
	    for (m = 0; m < grade; m++){
		    sum += *(matrix1 + row * grade + m) *  *(matrix2 + m * grade + col);
	    }
	    /* ulozeni hodnoty souradnice do vysledku */
      *(rslt + 2 * i + 1) = sum; 
    }
    cnt_work++;
    
    /* odeslani vysledku */  

    pvm_initsend(PvmDataDefault);/* inic. bufferu */

    pvm_pkint(&mytid, 1, 1);     /* ulozeni identifikace */

    pvm_pkint(&x_num, 1, 1);     /* pocet souradnic */
    pvm_pkint(rslt, x_num * 2, 1);     /* ulozeni vysledku */

    pvm_pkint(&cnt_work, 1, 1);  /* ulozeni citace prace */
    pvm_send(chief_tid, 7);      /* kod odpovedi 7 */
  }
  
  }

  /* ukonceni cinnosti */

  pvm_exit();

}
